net.sf.saxon.expr

## Class ForExpression

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.Assignation
    - - net.sf.saxon.expr.ForExpression

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, Binding, InstructionInfo, Locator
  Direct Known Subclasses:
    OuterForExpression

      public class ForExpression
      extends Assignation

  A ForExpression maps an expression over a sequence. This version works with range variables, it doesn't change the context information
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `ForExpression.EventMappingAction` The EventMappingAction represents the action to be taken for each item in the source sequence.
    `static class` | `ForExpression.MappingAction` The MappingAction represents the action to be taken for each item in the source sequence.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected PositionVariable` | `positionVariable`

    - ### Fields inherited from class net.sf.saxon.expr.Assignation

      `action, requiredType, sequence, slotNumber, variableName`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ForExpression()` Create a "for" expression (for $x at $p in SEQUENCE return ACTION)

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `int` | `computeCardinality()` Determine the static cardinality of the expression
    `Expression` | `copy()` Copy an expression.
    `void` | `evaluatePendingUpdates(XPathContext context, PendingUpdateList pul)` Evaluate an updating expression, adding the results to a Pending Update List.
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `protected void` | `explainSpecializedAttributes(ExpressionPresenter out)`
    `Binding[]` | `extendBindingList(Binding[] in)` Extend an array of variable bindings to include the binding(s) defined in this expression
    `int` | `getConstructType()` Get the type of this expression for use in tracing and diagnostics
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the For expression
    `String` | `getExpressionName()` Get a name identifying the kind of expression, in terms meaningful to a user.
    `int` | `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `IntegerValue[]` | `getIntegerBounds()` For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis.
    `ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression, if possible
    `PositionVariable` | `getPositionVariable()`
    `StructuredQName` | `getPositionVariableName()` Get the name of the position variable
    `protected int` | `getRangeVariableCardinality()` Get the cardinality of the range variable
    `int` | `getRequiredSlots()` Get the number of slots required.
    `int` | `getStreamability(int syntacticContext, boolean allowExtensions, List<String> reasons)` Get the "sweep" of this expression as defined in the W3C streamability specifications.
    `boolean` | `hasVariableBinding(Binding binding)`
    `boolean` | `isVacuousExpression()` Determine whether this is a vacuous expression as defined in the XQuery update specification
    `SequenceIterator` | `iterate(XPathContext context)` Iterate over the sequence of values
    `EventIterator` | `iterateEvents(XPathContext context)` Deliver the result of the expression as a sequence of events.
    `int` | `markTailFunctionCalls(StructuredQName qName, int arity)` Mark tail function calls: only possible if the for expression iterates zero or one times.
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Optimize the expression
    `void` | `process(XPathContext context)` Process this expression as an instruction, writing results to the current outputter
    `protected Expression` | `promoteWhereClause(Binding positionBinding)` Promote a WHERE clause whose condition doesn't depend on the variable being bound.
    `void` | `setPositionVariable(PositionVariable decl)` Set the reference to the position variable (XQuery only)
    `void` | `setSlotNumber(int nr)` Set the slot number for the range variable
    `String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression

    - ### Methods inherited from class net.sf.saxon.expr.Assignation

      `addReference, addToPathMap, checkForUpdatingSubexpressions, evaluateVariable, getAction, getIntegerBoundsForVariable, getLocalSlotNumber, getNominalReferenceCount, getObjectName, getRequiredType, getSequence, getVariableEQName, getVariableName, getVariableQName, isAssignable, isGlobal, isIndexedVariable, isUpdatingExpression, iterateSubExpressionInfo, iterateSubExpressions, promote, refineTypeInformation, replaceSubExpression, replaceVariable, setAction, setIndexedVariable, setRequiredType, setSequence, setVariableQName, simplify, suppressValidation`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, computeDependencies, computeSpecialProperties, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, explain, getCardinality, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamingAdjunct, getSystemId, getSystemId, implementsStaticTypeCheck, isSubtreeExpression, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, toPattern, toStreamingPattern, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### positionVariable

          protected PositionVariable positionVariable

  - ### Constructor Detail

    - #### ForExpression

          public ForExpression()

      Create a "for" expression (for $x at $p in SEQUENCE return ACTION)

  - ### Method Detail

    - #### getExpressionName

          public String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `Expression`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

    - #### setPositionVariable

          public void setPositionVariable(PositionVariable decl)

      Set the reference to the position variable (XQuery only)
      Parameters:
        `decl` - the range variable declaration for the position variable

    - #### getPositionVariable

          public PositionVariable getPositionVariable()

    - #### hasVariableBinding

          public boolean hasVariableBinding(Binding binding)

      Overrides:
        `hasVariableBinding` in class `Assignation`

    - #### getPositionVariableName

          public StructuredQName getPositionVariableName()

      Get the name of the position variable
      Returns:
        the name of the position variable ("at $p") if there is one, or null if not

    - #### setSlotNumber

          public void setSlotNumber(int nr)

      Set the slot number for the range variable
      Overrides:
        `setSlotNumber` in class `Assignation`
      Parameters:
        `nr` - the slot number allocated to the range variable on the local stack frame. This implicitly allocates the next slot number to the position variable if there is one.

    - #### getRequiredSlots

          public int getRequiredSlots()

      Get the number of slots required.
      Overrides:
        `getRequiredSlots` in class `Assignation`
      Returns:
        normally 1, except for a FOR expression with an AT clause, where it is 2.

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Type-check the expression
      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### getRangeVariableCardinality

          protected int getRangeVariableCardinality()

      Get the cardinality of the range variable
      Returns:
        the cardinality of the range variable (StaticProperty.EXACTLY_ONE). Can be overridden in a subclass

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Optimize the expression
      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### getIntegerBounds

          public IntegerValue[] getIntegerBounds()

      For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis. The default implementation returns null, meaning "unknown" or "not applicable". Other implementations return an array of two IntegerValue objects, representing the lower and upper bounds respectively. The values UNBOUNDED_LOWER and UNBOUNDED_UPPER are used by convention to indicate that the value may be arbitrarily large. The values MAX_STRING_LENGTH and MAX_SEQUENCE_LENGTH are used to indicate values limited by the size of a string or the size of a sequence.
      Overrides:
        `getIntegerBounds` in class `Expression`
      Returns:
        the lower and upper bounds of integer values in the result, or null to indicate unknown or not applicable.

    - #### promoteWhereClause

          protected Expression promoteWhereClause(Binding positionBinding)

      Promote a WHERE clause whose condition doesn't depend on the variable being bound. This rewrites an expression of the form

      let $i := SEQ return if (C) then R else ()

      to the form:

      if (C) then (let $i := SEQ return R) else ()

      Parameters:
        `positionBinding` - the binding of the position variable if any
      Returns:
        an expression in which terms from the WHERE clause that can be extracted have been extracted

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### markTailFunctionCalls

          public int markTailFunctionCalls(StructuredQName qName,
                                  int arity)

      Mark tail function calls: only possible if the for expression iterates zero or one times. (This arises in XSLT/XPath, which does not have a LET expression, so FOR gets used instead)
      Overrides:
        `markTailFunctionCalls` in class `Expression`
      Parameters:
        `qName` - the name of the function
        `arity` - the arity (number of parameters) of the function
      Returns:
        `UserFunctionCall.NOT_TAIL_CALL` if no tail call was found; `UserFunctionCall.FOREIGN_TAIL_CALL` if a tail call on a different function was found;

    - #### extendBindingList

          public Binding[] extendBindingList(Binding[] in)

      Extend an array of variable bindings to include the binding(s) defined in this expression
      Overrides:
        `extendBindingList` in class `Assignation`
      Parameters:
        `in` - a set of variable bindings
      Returns:
        a set of variable bindings including all those supplied plus this one

    - #### isVacuousExpression

          public boolean isVacuousExpression()

      Determine whether this is a vacuous expression as defined in the XQuery update specification
      Overrides:
        `isVacuousExpression` in class `Expression`
      Returns:
        true if this expression is vacuous

    - #### getImplementationMethod

          public int getImplementationMethod()

      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided. This implementation provides both iterate() and process() methods natively.
      Overrides:
        `getImplementationMethod` in class `Expression`
      Returns:
        the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

    - #### checkPermittedContents

          public void checkPermittedContents(SchemaType parentType,
                                    StaticContext env,
                                    boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `env` - the static context
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### getStreamability

          public int getStreamability(int syntacticContext,
                             boolean allowExtensions,
                             List<String> reasons)

      Get the "sweep" of this expression as defined in the W3C streamability specifications. This provides an assessment of stylesheet code against the W3C criteria for guaranteed streamability, and is implemented to allow these criteria to be tested. It is not the case that all expression that emerge as streamable from this analysis are currently capable of being streamed by Saxon
      Overrides:
        `getStreamability` in class `Expression`
      Parameters:
        `syntacticContext` - one of the values `Expression.NAVIGATION_CONTEXT`, `Expression.NODE_VALUE_CONTEXT`, `Expression.INHERITED_CONTEXT`, `Expression.INSPECTION_CONTEXT`
        `allowExtensions` - if false, the definition of "guaranteed streamability" in the W3C specification is used. If true, Saxon extensions are permitted, which make some
        `reasons` - the caller may supply a list, in which case the implementation may add to this list a message explaining why the construct is not streamable, suitable for inclusion in an error message.
      Returns:
        one of the values `Expression.W3C_MOTIONLESS`, `Expression.W3C_CONSUMING`, `Expression.W3C_GROUP_CONSUMING`, `Expression.W3C_FREE_RANGING`

    - #### iterate

          public SequenceIterator iterate(XPathContext context)
                                   throws XPathException

      Iterate over the sequence of values
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### iterateEvents

          public EventIterator iterateEvents(XPathContext context)
                                      throws XPathException

      Deliver the result of the expression as a sequence of events.
      Overrides:
        `iterateEvents` in class `Expression`
      Parameters:
        `context` - The dynamic evaluation context
      Returns:
        the result of the expression as an iterator over a sequence of PullEvent objects
      Throws:
        `XPathException` - if a dynamic error occurs during expression evaluation

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process this expression as an instruction, writing results to the current outputter
      Overrides:
        `process` in class `Expression`
      Parameters:
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### evaluatePendingUpdates

          public void evaluatePendingUpdates(XPathContext context,
                                    PendingUpdateList pul)
                                      throws XPathException

      Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException
      Overrides:
        `evaluatePendingUpdates` in class `Expression`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `pul` - the pending update list to which the results should be written
      Throws:
        `XPathException` - if evaluation fails

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Determine the data type of the items returned by the expression, if possible
      Specified by:
        `getItemType` in class `Expression`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        one of the values Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known in advance)

    - #### computeCardinality

          public int computeCardinality()

      Determine the static cardinality of the expression
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

    - #### toString

          public String toString()

      The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax
      Overrides:
        `toString` in class `Expression`
      Returns:
        a representation of the expression as a string

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

    - #### explainSpecializedAttributes

          protected void explainSpecializedAttributes(ExpressionPresenter out)

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the For expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### getConstructType

          public int getConstructType()

      Get the type of this expression for use in tracing and diagnostics
      Specified by:
        `getConstructType` in interface `InstructionInfo`
      Overrides:
        `getConstructType` in class `Expression`
      Returns:
        the type of expression, as enumerated in class `Location`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.